/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   ft_list.h                                          :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: ale-batt <ale-batt@student.42.fr>          +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2015/12/08 16:11:47 by ale-batt          #+#    #+#             */
/*   Updated: 2016/01/15 11:05:54 by ale-batt         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#ifndef FT_LIST_H
# define FT_LIST_H

# include "libft.h"

typedef struct		s_list
{
	void			*content;
	size_t			content_size;
	struct s_list	*next;
}					t_list;

typedef struct		s_llist
{
	void			*content;
	struct s_llist	*next;
	struct s_llist	*prev;
}					t_llist;

t_list				*ft_lstnew(void const *content, size_t content_size);
void				ft_lstadd(t_list **alst, t_list *new);
void				ft_lstadd_end(t_list **alst, t_list *new);
void				ft_lstdel(t_list **alst, void (*del)(void *, size_t));
void				ft_lstdelone(t_list **alst, void (*del)(void *, size_t));
void				ft_lstiter(t_list *lst, void (*f)(t_list *elem));
t_list				*ft_lstmap(t_list *lst, t_list *(*f)(t_list *elem));
t_list				*ft_tab_to_list(char **tab);
int 				ft_lstlen(t_list *lst);
t_list				*ft_lstcpy(t_list *list);
void				ft_lstfree(t_list *lst);

t_llist				*ft_llstnew(void const *content);
void				ft_llstadd(t_llist **alst, t_llist *new);
void				ft_llstadd_end(t_llist **alst, t_llist *new);
int 				ft_llstlen(t_llist *lst);
t_llist				*ft_llstcpy(t_llist *list);
void				ft_llstfree(t_llist *lst);

#endif
