/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   printf.h                                           :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: ale-batt <ale-batt@student.42.fr>          +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2015/01/24 19:41:02 by ale-batt          #+#    #+#             */
/*   Updated: 2015/09/17 13:22:22 by ale-batt         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#ifndef PRINTF_H
# define PRINTF_H

# define I data->index
# define TYPES "%lhjzdipxXsScCuUoOD\0"

# define ULL unsigned long long

# define PCOLOR(x, y) ft_putstr_color(x, y)
# define PGREEN(x)	ft_putstr_color(x, "green")

# include "libft.h"
# include <stdarg.h>
# include <locale.h>
# include <wchar.h>

typedef struct		s_printf
{
	int				index;
	int				ret;
	struct s_info	*info;
	t_list			*list;
	int				len_s;
	int				is_neg;
}					t_printf;

typedef struct		s_info
{
	char			*param;
	char			*flags;
	int				larg_nb;
	int				zero;
	int				precision;
	short			boolpreci;
	char			type;
	int				i_ret;
	intmax_t		im_ret;
	uintmax_t		uim_ret;
	char			c_ret;
	unsigned char	uc_ret;
	char			*ch_ret;
	long			l_ret;
	long int		li_ret;
	long long		ll_ret;
	ULL				ull_ret;
	unsigned int	ui_ret;
	unsigned long	ul_ret;
	short			s_ret;
	unsigned short	us_ret;
	int				len_s;
	t_list			*uni_s;
}					t_info;

typedef struct		s_opt
{
	char			*mask;
	wchar_t			*wret;
	char			*bin;
	int				nb_byt;
	long int		*unicode;
}					t_opt;

typedef struct		s_donnee
{
	char			*flpm;
	int				largeur;
}					t_donnee;

int					ft_printf(char *str, ...);
int					read_str(char *str, va_list ap);

t_printf			*init_printf(t_printf *data);
t_info				*init_info(t_info *info);
t_info				*init_info_ret(t_info *info);

void				print_s(t_info *info, t_printf *data);

t_info				*analyse_param(char *str, va_list ap, t_printf *data);
t_info				*analyse_param_p2(char *str, va_list ap,
					t_printf *data, t_info *new);
void				simple_flag(char *str, va_list ap, t_printf *d, t_info *n);
void				simple_flag_part2(char *str, va_list a,
					t_printf *data, t_info *new);
void				simple_flag_part3(char *str, va_list a,
					t_printf *data, t_info *new);
void				h_flag(char *str, va_list ap, t_printf *data, t_info *new);
void				hh_flag(char *str, va_list ap, t_printf *data, t_info *new);
void				jz_flag(char *str, va_list ap, t_printf *data, t_info *new);
void				z_flag(char *str, va_list ap, t_printf *data, t_info *new);

void				l_flag(char *str, va_list ap, t_printf *data, t_info *new);
void				l_flag_part2(char *str, va_list ap, t_printf *d, t_info *n);
void				ll_flag(char *str, va_list ap, t_printf *data, t_info *new);

int					modificateur(char *str, va_list ap, t_printf *d, t_info *n);

char				*read_infos(char *str, t_printf *data, t_info *info);
void				get_largeur(char *str);

void				flags(char *str, t_printf *data, t_info *info);
void				ret_flags(t_printf *data, t_info *info);

void				largeur(char *str, t_printf *data, t_info *info);
void				ret_largeur(t_printf *data, t_info *info);

void				precision(char *str, t_printf *data, t_info *info);
void				ret_precision(t_printf *data, t_info *info);
void				ret_s_precision(t_printf *data, t_info *info);

void				printf_color(char *str, t_printf *data);

char				*ft_strfill(int nb, char c);
char				*ft_strupcase(char *str);
char				*ft_stresize(char *str, int size);
char				*ft_fillin(char *str, char *fill, int size);
char				*ft_strjump(char *str, int size);

int					ft_cput(char *str);
void				ft_putnbr_lint(long int nb);
void				ft_putnbr_ui(unsigned int nb);
void				ft_putnbr_ul(unsigned long nb);
void				ft_putnbr_ull(unsigned long long nb);

intmax_t			ft_atoi_imax(const char *str);
char				*ft_itoa_imax(intmax_t n);
char				*ft_itoa_ull(unsigned long long n);

char				*tochar(char c);
char				*hexa(unsigned long long c);
char				*to_octal(unsigned long long c);
char				*to_binary(wchar_t c);
long int			bin_to_dec(long int bin);

int					unicodelen(long int *unicode);

int					ft_wstrlen(wchar_t *str);
void				ft_wputstr(wchar_t *str);

char				*option_x(char c, unsigned long long ret);

void				option_s(t_printf *data, va_list ap, t_info *new);
void				option_c(t_printf *data, va_list ap);
int					ft_nb_byt(char *bin);
char				*fill_mask(char *mask, char *bin);
long int			*mask_to_int(char *mask);

int					ft_putunicode(long int *uni);
void				print_unicode(t_list *list, t_printf *data);

#endif
