/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   signal_handler.c                                   :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: ale-batt <ale-batt@student.42.fr>          +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2016/01/20 15:46:30 by ale-batt          #+#    #+#             */
/*   Updated: 2016/01/25 18:50:31 by ale-batt         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "ft_select.h"

void			ft_signal_on(void)
{
	signal(SIGINT, SIG_IGN);
	signal(SIGWINCH, &signal_handler);
	signal(SIGTSTP, &signal_handler);
	signal(SIGCONT, &signal_handler);
}

void			ft_signal_off(void)
{
	signal(SIGINT, SIG_DFL);
	signal(SIGWINCH, SIG_DFL);
	signal(SIGTSTP, SIG_DFL);
	// signal(SIGCONT, SIG_DFL);
}

static void		handle_sigtstp(void)
{
	if (isatty(1))
	{
		ft_terminal_off(&g_term_save);	// term_restore(&(ENV->term));
		ft_signal_off();
		ioctl(0, TIOCSTI, "\032");
	}
}

static void		handle_sigcont(void)
{
	if (isatty(1))
	{
		ft_signal_on();
		ft_terminal_on();
		print_list();
	}
}

static void		handle_sigwinch(void)
{
	signal(SIGWINCH, SIG_IGN);
	print_list();
	signal(SIGWINCH, &signal_handler);
}

void			signal_handler(int sig)
{
	if (sig == SIGTSTP)
		handle_sigtstp();
	if (sig == SIGCONT)
		handle_sigcont();
	if (sig == SIGWINCH)
		handle_sigwinch();
	// if (sig == SIGINT || sig == SIGTERM)
    // handle_killers();
}
