/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   terminal.c                                         :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: ale-batt <ale-batt@student.42.fr>          +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2016/01/24 16:25:32 by ale-batt          #+#    #+#             */
/*   Updated: 2016/01/25 14:42:04 by ale-batt         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "ft_select.h"

int		ft_terminal_on(void)
{
	struct termios	tc;
	char			*term_name;

	if ((term_name = getenv("TERM")) == NULL || tgetent(NULL, term_name) <= 0)
		term_name = "xterm";
	if (tgetent(NULL, term_name) <= 0)
		return (-1);
	if (tcgetattr(0, &tc) < 0)
		return (-1);
	ft_memcpy(&g_term_save, &tc, sizeof(struct termios));
	tc.c_lflag &= ~(ECHO | ECHOE | ECHOK | ECHONL | ICANON);
	tc.c_cc[VMIN] = 1;
	tc.c_cc[VTIME] = 0;
	if (tcsetattr(0, TCSADRAIN, &tc) < 0)
		return (-1);
	tputs(ft_tgetstr("ti"), AFFCNT, ft_iputchar);
	tputs(ft_tgetstr("vi"), AFFCNT, ft_iputchar);
	// term_update(term);
	return (1);
}

int 	ft_terminal_off(struct termios *term)
{
	ft_clear_screen();
	tputs(ft_tgetstr("te"), AFFCNT, ft_iputchar);
	tputs(ft_tgetstr("ve"), AFFCNT, ft_iputchar);
	if (tcsetattr(0, TCSADRAIN, term) < 0)
	{
		puts("Error: term off");
		return (-1);
	}
	return (1);
}
